	PAGE	60,132
NAME	HDSNIFF
	TITLE	HDSniff.Com Version 1.0
Comment @

Tells you how your AT/XT hard disks were low-level formatted.
Needs no parameters.
example of use:

HdSniff
or
HDSniff | More
or
HDSniff >Temp.Dat

by Roedy Green
   Canadian Mind Products
   1150 Homer Street
   Vancouver BC
   Canada V6B 2X8
   (604) 684-6529

Written 1988 April 6.

This program is in the public domain.  It may be used for any
purpose except military.

Future possible enhancements include:
 0. display the AT drive type.
 1. calculate the current interleave and suggest the optimum.
 2. display the partition sizes.
 3. display the cluster sizes of each partition.
 4. display other partition stats such as free space,
    number of directories, location of interesting tables.
 5. Determine AT vs XT then trim the display.
 6. Determine the DOS version in MSDOS.SYS and Command.com

@ ; end of comment

;===========================
CR	MACRO	; Carriage return line feed
	DB 0dh,0ah
	ENDM
;============================
EOS	MACRO	; marks end of display string
	DB 0dh,0ah,'$'
	ENDM
;============================
;	register conventions:
;	preserved across calls DS: CS: ES: SS: CX SI DI
;	trashed across calls AX BX DX
;============================

DriveTab Struc			; Drive Table accessible Via
				; BIOS int 41H
	Max_Cyl dw ?		; Max number of cylinders
	Max_Heads db ?		; Max number of heads
	Red_Write_Cyl dw ?	; starting reduced write cylinder
	Precomp_Cyl dw ?	; starting write precompensation
	Ecc_Burst db ?		; max ECC burst length (bits)
	Step_Control db ?	;
	Std_TimeOut db ?
	Fmt_TimeOut db ?
	Chk_TimeOut db ?
	Land_Zone dw ?
	Sects_Per_Track db ?
	reserved    db ?	; 1 byte reserved
DriveTab Ends

;============================

code	segment para
	assume	cs:code,ds:code
	org	100h

HDSniff proc	far

start:
	lea	dx,Welcome$
	Call	Say
	mov	di,0080h	; drive no. for c:
	mov	dx,di		; get drv parms for disk c:
	mov	ax,0800h	; ah 08 = get disk parameters
	int	13h		; into CX/DX

	mov	cl,dl		; put drv count in cx
	xor	ch,ch		; zero high order byte of drive count
	jcxz	quit		; zero drives--exit procedure
	xor	DI,DI		; loop with DI=0,1,2...
sloop:				; loop once for each drive c: d:...
	call	Sniff1
	inc	DI		; inc to next drive  D:
	loop	sloop

quit:	lea	dx,Bye$
	Call	Say
	mov	ax,4c00h	; exit to DOS
	int	21h
;============
Say	Proc
;	on entry DX points to a string to display terminated by $
;	displays string
	MOV	AH,9
	Int	21h
	ret
Say	EndP
;============
SayNum PROC Near
;	on entry displays number in AX in Decimal and [hex]
	PUSH	AX
	Call	SayDec
	lea	dx,leftbr$
	Call	Say
	POP	AX
	Call	SayHex
	lea	dx,rightbr$
	Call	Say
	ret
SayNum	EndP
;============

SayDec PROC	NEAR
;	call with number in range 0..65535 in AX
;	converts it to ASCII and displays it on the screen
;	If it is 0 shows as 0.
;	leading 0's are suppressed.
;	field is exactly wide enough to hold the number.
;	No leading or trailing spaces.	DISPLAYED IN DECIMAL
	PUSH	DI		; preserve DI
	MOV	BX,10d
	MOV	DI,5		; work right to left building digits at PAD
SayDecLoop:
	DEC	DI
	XOR	DX,DX		; DX:AX / 10
	DIV	BX		; AX=quot DX=remdr
	ADD	DL,'0'		; convert digit to ASCII
	MOV	PAD[DI],DL
	OR	AX,AX
	JNZ	SayDecLoop
SayDecDone:
;	Number is ready
	lea	dx,pad[di]
	call	Say		; terminated by $
	POP	DI
	RET
SayDec	ENDP
;========================
SayHex PROC	NEAR
;	call with number in range 0..65535 in AX
;	converts it to ASCII and displays it on the screen
;	If it is 0 shows as 0.
;	leading 0's are suppressed.
;	field is exactly wide enough to hold the number.
;	No leading or trailing spaces.	DISPLAYED IN HEX
;	This is not the fastest way of doing HEX, but it was
;	quickest to code given I had already written SayDec.
	PUSH	DI		; preserve DI
	MOV	BX,10h
	MOV	DI,5		; work right to left building digits at PAD
SayHexLoop:
	DEC	DI
	XOR	DX,DX		; DX:AX / 10h
	DIV	BX		; AX=quot DX=remdr
	CMP	DL,9
	JG	HexChar
	ADD	DL,'0'		; convert digit to ASCII
	JMP	StoreChar
HexChar:
	ADD	DL,'A'-0ah	; convert A..H
StoreChar:
	MOV	PAD[DI],DL
	OR	AX,AX
	JNZ	SayHexLoop
SayHexDone:
;	Number is ready
	lea	dx,pad[di]
	call	Say		; terminated by $
	POP	DI
	RET
SayHex	ENDP

;=================================
Sniff1	PROC	Near
;	prints out drive table for 1 drive
;	DI indexes drive wanted usually 0 = C: 1= D:
;	Sacrosanct ES:SI points to the drive table
	PUSH	CX
	PUSH	DI
	Lea	DX,Disk_no$	; describe which disk 0=C:
	Call	Say
	MOV	AX,DI		; disk number decimal only
	CALL	SayDec
	Lea	DX,Disk_noC$
	Call	Say

	SHL	DI,1		; multiply DI by 16 to offset
	SHL	DI,1		; into proper 16-byte drive table
	SHL	DI,1
	SHL	DI,1

	mov	al,41h
	mov	ah,35h		; get int 41 pointer to drive table
	int	21h		; ES:BX points to drive table
				; get drive table info
	MOV	SI,BX		; save address in SI so wont get
				; trashed
	ADD	SI,DI		; add on offset
	mov	ax,ES:[SI].Max_Cyl
	Call	SayNum
	lea	dx,Max_Cyl$
	Call	Say

	mov	al,ES:[SI].Max_Heads
	xor	ah,ah
	Call	SayNum
	Lea	dx,Max_Heads$
	Call	Say

	mov	ax,ES:[SI].Red_Write_Cyl
	Call	SayNum
	lea	dx,Red_Write_Cyl$
	Call	Say

	mov	ax,ES:[SI].Precomp_Cyl
	Call	SayNum
	lea	dx,Precomp_Cyl$
	Call	Say

	mov	al,ES:[SI].Ecc_Burst
	xor	ah,ah
	Call	SayNum
	lea	dx,Ecc_Burst$
	Call	Say

	mov	al,ES:[SI].Step_Control
	xor	ah,ah
	Call	SayNum
	lea	dx,Step_Control$
	Call	Say

	mov	al,ES:[SI].Std_TimeOut
	xor	ah,ah
	Call	SayNum
	lea	dx,Std_TimeOut$
	Call	Say

	mov	al,ES:[SI].Fmt_TimeOut
	xor	ah,ah
	Call	SayNum
	lea	dx,Fmt_TimeOut$
	Call	Say

	mov	al,ES:[SI].Chk_TimeOut
	xor	ah,ah
	Call	SayNum
	lea	dx,Chk_TimeOut$
	Call	Say

	mov	ax,ES:[SI].Land_Zone
	Call	SayNum
	lea	dx,Land_Zone$
	Call	Say

	mov	al,ES:[SI].Sects_Per_Track
	xor	ah,ah
	Call	SayNum
	lea	dx,Sects_Per_Track$
	Call	Say
	POP	DI
	POP	CX
	RET
Sniff1	ENDP
;======================

;======================================
	EVEN
PAD	DB	"00000$"	; where numeric output built by SayNum
;======================================
Welcome$ Label Byte
	CR
	db 'HDSniff version 1.0'
	db '   Public domain.'
	db '   Non military use only.'
	CR
	db 'Ferrets out the parameters that were used to perform'
	CR
	db 'the last low-level hard disk format.'
	CR
	db 'All numbers are both in decimal and [hex].'
	EOS

Disk_No$ Label Byte
	CR
	db 'Low level formatting parameters for DISK $'

Disk_NoC$ Label Byte
	db '   [0=C: 1=D:]'
	EOS

leftbr$ label Byte
	db ' [$'

rightbr$ label Byte
	db ']$'

Max_Cyl$ Label Byte
	db ' = Number of cylinders '
	EOS

Max_Heads$ label Byte
	db ' = Number of heads '
	EOS

Red_Write_Cyl$ label Byte
	db ' = XT Starting cylinder for reduced write current '
	EOS

Precomp_Cyl$ label Byte
	db ' = Starting cylinder for write precompensation '
	EOS

Ecc_Burst$ label Byte
	db ' = XT Maximum bits of error burst to attempt to correct'
	db ' (usually 8 to 11)'
	EOS

Step_Control$ label Byte
	db ' = Step control byte'
	CR
	db '   (bit 7 = disable retries; bit 6 = disable ECC retries)'
	CR
	db '   (AT bit 3 = more than 8 heads)'
	CR
	db '   (XT bits 2..0 = STEP PULSE rate, usually faster than STEP rate)'
	CR
	db '   (0,1,2,6,7 = 3 milliseconds; 4 = 200 microseconds; 5 = 70 microseconds)'
	CR
	db '   (3 = 12 microseconds - not always available)'
	EOS

Std_TimeOut$ label byte
	db ' = XT Standard timeout value'
	EOS

Fmt_TimeOut$ label byte
	db ' = XT Formatting timeout value'
	EOS

Chk_TimeOut$ label byte
	db ' = XT Disk check timeout value'
	EOS

Land_Zone$ label byte
	db ' = AT landing zone (usually the last Cylinder)'
	EOS

Sects_Per_Track$ label byte
	db ' = AT sectors per track (usually 17 for MFM, 26 for RLL)'
	EOS

Bye$	db 'Love Roedy'
	EOS
HDSniff endp
code	ends
	end	start
